package org.apache.accumulo.test;

import java.io.IOException;

import org.apache.accumulo.tserver.compaction.CompactionPlan;
import org.apache.accumulo.tserver.compaction.CompactionStrategy;
import org.apache.accumulo.tserver.compaction.MajorCompactionRequest;
import org.apache.hadoop.io.Text;

public class EfgCompactionStrat extends CompactionStrategy {

  @Override
  public boolean shouldCompact(MajorCompactionRequest request) throws IOException {
    Text er = request.getExtent().getEndRow();
    return er != null && er.toString().equals("efg") && request.getFiles().size() > 1;
  }

  @Override
  public CompactionPlan getCompactionPlan(MajorCompactionRequest request) throws IOException {
    CompactionPlan cp = new CompactionPlan();
    cp.inputFiles.addAll(request.getFiles().keySet());
    return cp;
  }

}
